/*
 Example1104Abis : JJ2 line following demo
 state machine model: this part is tranferred from
 Mr. Kamura's sketch.
 H. Kawakami November 15, 2014
*/

#include <Servo.h> 

const int servoL_Pin = 9; 
const int servoR_Pin = 5; 

Servo servoL;  
Servo servoR;  

int centerR=1500, centerL=1500, pw=700;

void setup() { 
  delay(1000); 
  servoL.attach(servoL_Pin, centerL-pw, centerL+pw); 
  servoR.attach(servoR_Pin, centerR-pw, centerR+pw);
  Serial.begin(9600);  
} 

int spd=30;

void fwd(){
    servoL.write(90-spd);
    servoR.write(90+spd); 
}

void stp(){
    servoL.write(90);
    servoR.write(90);
}

void rot_CCW(){
    servoL.write(90);
    servoR.write(90+spd); 
}

void rot_CW(){
    servoL.write(90-spd);
    servoR.write(90);  
}

void prtData(int x, int y, int z){ 
  Serial.print("val_L:");
  Serial.print(x,DEC);
  Serial.print("   val_C:");
  Serial.print(y,DEC);
  Serial.print("   val_R:");
  Serial.println(z,DEC);
}

int th=600;
boolean sen_L, sen_C, sen_R, b_fwd, b_stp;
enum{
 JJ2_STP,
 JJ2_FWD,
 JJ2_CW,
 JJ2_CCW
}state=JJ2_STP;

void loop() {
  sen_L=analogRead(A0)>th;
  sen_C=analogRead(A1)>th;
  sen_R=analogRead(A2)>th;
  b_fwd=!(sen_L) && sen_C && !(sen_R);
  b_stp=sen_L && sen_C && sen_R;
  
  switch(state){
    case JJ2_STP: //stop
      if(b_fwd){
        state=JJ2_FWD;
        fwd();
      }
      break;
    case JJ2_FWD: //forward direction
      if(b_stp){
        state=JJ2_STP;
        stp();
      }else if(sen_R){
        state=JJ2_CW;
        rot_CW();
      }else if(sen_L){
        state=JJ2_CCW;
        rot_CCW();
      }
      break;
    case JJ2_CW:  //clockwise rotation
      if(b_stp){
        state=JJ2_STP;
        stp();
      }else if(b_fwd){
        state=JJ2_FWD;
        fwd();
      }
      break;
    case JJ2_CCW:  //counter clockwise rotation
      if(b_stp){
        state=JJ2_STP;
        stp();
      }else if(b_fwd){
        state=JJ2_FWD;
        fwd();
      }
      break;
  }
  delay(40);
}
